<?php

/**
 * webEdition CMS
 *
 * $Rev: ff6cef894584 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-06-28 12:16 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_doclist_search extends we_search_search{
	public $View;
	protected $whichSearch;

	public function __construct(we_modules_view $view = null){
		parent::__construct($view);
		$this->whichSearch = we_search_view::SEARCH_DOCLIST;
	}

	public function searchProperties($model, $table = ''){ // FIXME: handle model in like in other searches
		$DB_WE = new DB_WE();
		$foundItems = 0;
		$result = $saveArrayIds = $currentSearch = [];
		$_SESSION['weS']['weSearch']['foundItems'] = 0;

		$currentSearchFields = $model->getProperty('currentSearchFields');
		$currentSearch = $model->getProperty('currentSearch');
		$table = $table ?: (($t = $model->getProperty('currentSearchTables')) ? $t[0] : FILE_TABLE);
		$currentLocation = $model->getProperty('currentLocation');
		$currentOrder = $model->getProperty('currentOrder');
		//$view = $model->getProperty('currentSetView');
		$currentSearchstart = $model->getProperty('currentSearchstart');
		$currentAnzahl = $model->getProperty('currentAnzahl');
		$currentFolderID = $model->getProperty('currentFolderID');

		$where = [];
		$this->settable($table);

		if($currentFolderID){
			$this->createTempTable();

			foreach($currentSearchFields as $i => $searchField){
				if(isset($currentSearch[0])){
					$searchString = (isset($currentSearch[$i]) ? $currentSearch[$i] : $currentSearch[0]);
				}
				if(!empty($searchString)){

					switch($searchField){
						default:
						case 'Text':
							if(isset($searchField) && isset($currentLocation[$i])){
								$where[] = ($this->searchfor([$searchString], [$searchField], [$currentLocation[$i]], 'WETABLE') ?: ' 0 ');
							}
						case 'Content':
						case we_contents_root::TITLE_FIELD:
						case 'Status':
						case 'Speicherart':
						case 'CreatorName':
						case 'WebUserName':
						case 'temp_category':
							break;
					}

					switch($searchField){
						case 'Content':
							$where[] = ($this->searchContent($searchString, $table) ?: '0');
							break;

						case we_contents_root::TITLE_FIELD:
							break;
						/*
						  $w = $this->searchInTitle($searchString, $table);
						  $where[] = ($w ? $w : '0');
						 *
						 */
						case 'Status':
						case 'Speicherart':
							if($searchString && in_array($table, [FILE_TABLE, OBJECT_FILES_TABLE])){
								if($searchString === 'deleted'){
									switch($table){
										case OBJECT_FILES_TABLE:
											$_SESSION['weS']['weSearch']['onlyObjects'] = true;
											break;
										case FILE_TABLE:
											$_SESSION['weS']['weSearch']['onlyDocs'] = true;
											break;
									}

									$table = VERSIONS_TABLE;
								}
								$where[] = $this->getStatusFiles($searchString, $table);
							}
							break;
						case 'CreatorName':
						case 'WebUserName':
							if($searchString){
								$where[] = $this->searchSpecial($searchString, $searchField, $currentLocation[$i]);
							}
							break;
						case 'temp_category':
							$where[] = $this->searchCategory($searchString, $table);
							break;
					}
				}
			}

			$where[] = 'WETABLE.ParentID=' . intval($currentFolderID);
			switch($table){
				case FILE_TABLE:
					$where[] = '(WETABLE.RestrictOwners=0 OR WETABLE.CreatorID=' . intval($_SESSION['user']['ID']) . ' OR FIND_IN_SET(' . intval($_SESSION['user']['ID']) . ',WETABLE.Owners))';
					break;
				case TEMPLATES_TABLE:
					//$where[] = 'AND (RestrictUsers IN (0,' . intval($_SESSION['user']['ID']) . ') OR FIND_IN_SET(' . intval($_SESSION['user']['ID']) . ',Users))';
					break;
				case OBJECT_FILES_TABLE :
					$where[] = '(WETABLE.RestrictOwners=0 OR WETABLE.CreatorID=' . intval($_SESSION['user']['ID']) . ' OR FIND_IN_SET(' . intval($_SESSION['user']['ID']) . ',WETABLE.Owners))';
					break;
				case OBJECT_TABLE :
					$where[] = '(WETABLE.RestrictUsers=0 OR WETABLE.CreatorID=' . intval($_SESSION['user']['ID']) . ' OR FIND_IN_SET(' . intval($_SESSION['user']['ID']) . ',WETABLE.Users))';
					break;
			}
			$whereQuery = implode(' AND ', array_filter($where));
			$this->setwhere($whereQuery);
			$this->insertInTempTable($whereQuery, $table, id_to_path($currentFolderID) . '/');

			$foundItems = $this->countitems($whereQuery, $table);
			$_SESSION['weS']['weSearch']['foundItems'] = $this->founditems = $foundItems;

			$this->selectFromTempTable($currentSearchstart, $currentAnzahl, $currentOrder);

			while($this->next_record()){
				if(!isset($saveArrayIds[$this->Record['ContentType']][$this->Record['docID']])){
					$saveArrayIds[$this->Record['ContentType']][$this->Record['docID']] = $this->Record['docID'];
					$result[] = array_merge(['Table' => $table], $this->Record);
				}
			}
		}

		if(!$this->founditems){
			return [];
		}
		//$this->createTempTable();

		foreach($result as &$v){
			$v[we_contents_root::DESCRIPTION_FIELD] = '';
			switch($v['Table']){
				case stripTblPrefix(FILE_TABLE):
					if($v['Published'] >= $v['ModDate'] && $v['Published'] != 0){
						$v[we_contents_root::DESCRIPTION_FIELD] = f('SELECT c.Dat FROM ' . FILE_TABLE . ' f LEFT JOIN ' . CONTENT_TABLE . ' c ON (f.ID=c.DID) WHERE f.ID=' . intval($v['docID']) . ' AND c.nHash=x\'' . md5('Description') . '\' AND c.DocumentTable="' . stripTblPrefix(FILE_TABLE) . '"');
						continue 2;
					}
					if(($obj = f('SELECT DocumentObject FROM ' . TEMPORARY_DOC_TABLE . ' WHERE DocumentID=' . intval($v['docID']) . ' AND DocTable="' . stripTblPrefix(FILE_TABLE) . '"'))){
						$tempDoc = we_unserialize($obj);
						if(isset($tempDoc[0]['elements'][we_contents_root::DESCRIPTION_FIELD]) && $tempDoc[0]['elements'][we_contents_root::DESCRIPTION_FIELD]['dat']){
							$v[we_contents_root::DESCRIPTION_FIELD] = $tempDoc[0]['elements'][we_contents_root::DESCRIPTION_FIELD]['dat'];
						}
					}
			}
		}

		return $result;
	}

}
