<?php

/**
 * webEdition CMS
 *
 * $Rev: b2e2950d4ecc $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:56 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_noTmpl extends we_editor_base{

	public function show(){
		require_once(WE_INCLUDES_PATH . 'we_tag.inc.php');
		$keyw = $this->we_doc->getElement(we_contents_root::KEYWORD_FIELD, we_contents_base::ETYPE_TEXT);
		$charset = $this->we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT);
		$desc = $this->we_doc->getElement(we_contents_root::DESCRIPTION_FIELD, we_contents_base::ETYPE_TEXT);

		if(!empty($GLOBALS['we']['editmode'])){
			$foo = '<html><head>' .
				($keyw ? we_html_element::meta(['name' => 'keywords', 'content' => $keyw]) : '') .
				($charset ? we_html_tools::metaCtCharset($charset) : '') .
				($desc ? we_html_element::meta(['name' => 'description', 'content' => $desc]) : '');
		}

		return we_html_element::docType() . '
<html>
	<head>' .
			(!empty($GLOBALS['we']['editmode']) ? STYLESHEET : '') .
			($charset ? we_html_tools::metaCtCharset($charset) : '') .
			($keyw ? '<meta name="keywords" content="' . $keyw . '">' : '') .
			($desc ? '<meta name="description" content="' . $desc . '">' : '') .
			'<title>' . $this->we_doc->getElement('Title') . '</title>' .
			(!empty($GLOBALS['we']['editmode']) ?
			we_html_element::jsScript(JS_DIR . 'global.js', 'initWE();') . we_editor_script::get() :
			we_tag('textarea', ['name' => 'HEAD'])
			) .
			'</head>' .
			(!empty($GLOBALS['we']['editmode']) ? '
		<body style="margin:15px;">
			<form name="we_form" method="post">' . we_contents_base::hiddenTrans() .
			we_html_tools::messageBox(667, 650, '<pre class="defaultfont">' . oldHtmlspecialchars($foo . we_html_element::title($this->we_doc->getElement(we_contents_root::TITLE_FIELD))) . '
</pre>
	' . we_tag('textarea', ['name' => 'HEAD', 'rows' => 8, 'cols' => 80, 'wrap' => 'virtual', 'style' => 'width: 600px;']) . '<br/>
<pre class="defaultfont">	&lt;/head&gt;
	&lt;body ' . we_tag('input', ['type' => 'text', 'size' => 60, 'name' => 'BODYTAG', 'style' => 'width: 480px;']) . '&gt;</pre>
' . we_tag('textarea', ['name' => 'BODY', 'rows' => 15, 'cols' => 80, 'wrap' => 'virtual', 'style' => 'width: 600px;']) . '
<pre class="defaultfont">	&lt;/body&gt;
&lt;/html&gt;</pre>') .
			we_html_element::hidden("we_complete_request", 1) .
			'</form>
		</body>' :
			'<body ' . we_tag('input', ['name' => 'BODYTAG']) . '>' .
			we_tag('textarea', ['name' => 'BODY'], '') .
			'</body>') .
			'</html>';
	}

}
