<?php

class we_mail_mimeMultiPartRelated extends we_mail_mimePart{
	protected $_mime = null;
	protected $_parts = [];

	public function __construct(we_mail_mimePart $content){
		$this->type = we_mail_mime::MULTIPART_RELATED . '; type=' . $content->type;
		$this->_mime = new we_mail_mime();
		$this->boundary = $this->_mime->boundary();
		$this->_parts[] = $content;
	}

	/**
	 * Append a new Mime_Part to the current message
	 *
	 * @param we_mail_mimePart $part
	 */
	public function addPart(we_mail_mimePart $part){
		/**
		 * @todo check for duplicate object handle
		 */
		$this->_parts[] = $part;
	}

	public function getContent($EOL = we_mail_mime::LINEEND){
		$boundaryLine = $this->_mime->boundaryLine($EOL);
		$body = '';
		foreach($this->_parts as $part){
			$body .= $boundaryLine .
				$part->getHeaders($EOL) .
				$EOL .
				$part->getContent($EOL);
		}

		$body .= $this->_mime->mimeEnd($EOL);
		return trim($body);
	}

}
