<?php

/**
 * webEdition CMS
 *
 * $Rev: fa4f6cfc57b2 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-09-05 21:02 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_condition extends we_weTag_tag{
	public static $conditionName = '';
	private static $count = 0;

	public static function parse(array $attribs, $content){
		$attribs['_type'] = 'start';
		return '<?php ' . we_weTag_parser::printTag('condition', $attribs) . ';?>' . $content . '<?php ' . we_weTag_parser::printTag('condition', ['_type' => 'stop']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$name = self::getAttribute('_name_orig', $attribs, 'we_lv_condition', we_base_request::STRING);
		//internal Attribute
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':

				self::$count++;

				if(self::$count == 1){
					self::$conditionName = $name;
					$GLOBALS[self::$conditionName] = '(';
				} else {
					$GLOBALS[self::$conditionName] .= '(';
				}
				break;
			case 'stop':
				$GLOBALS[self::$conditionName] .= ')';
				$GLOBALS[self::$conditionName] = str_replace('()', '', $GLOBALS[self::$conditionName]);
				self::$count --;
				if(self::$count == 0){
					self::$conditionName = '';
				}
				break;
		}
		return '';
	}

}

function we_tag_condition(array $attribs){
	return we_tag_condition::tag($attribs);
}
