<?php

/**
 * webEdition CMS
 *
 * $Rev: 1eac1923b962 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-10-22 17:36 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifClient extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$br = we_base_browserDetect::inst();

		if(($browser = self::getAttribute('browser', $attribs, [], we_base_request::STRING_LIST))){
			$browserOfClient = $br->getBrowser();
			$browserMatched = in_array($browserOfClient, $browser) ||
				// for backwards compatibility
				((we_base_browserDetect::isNN() && in_array('mozilla', $browser)) ||
				($browserOfClient == we_base_browserDetect::APPLE && in_array('safari', $browser)));
			if(!$browserMatched){
				return false;
			}
		}

		if(($version = self::getAttribute('version', $attribs, 0, we_base_request::FLOAT))){
			$brv = $br->getBrowserVersion();
			switch(self::getAttribute('operator', $attribs, '', we_base_request::STRING)){
				case 'equal':
					$versionMatched = (floor(floatval($brv)) == floor($version));
					break;
				case 'less':
					$versionMatched = (floatval($brv) < $version);
					break;
				case 'less|equal':
					$versionMatched = (floatval($brv) <= $version);
					break;
				case 'greater':
					$versionMatched = (floatval($brv) > $version);
					break;
				case 'greater|equal':
					$versionMatched = (floatval($brv) >= $version);
					break;
				default:
					$versionMatched = false;
					break;
			}
			if(!$versionMatched){
				return false;
			}
		}

		$system = array_map('strtolower', self::getAttribute('system', $attribs, [], we_base_request::STRING_LIST));

		return ($system ? in_array($br->getSystem(), $system) : true);
	}

}

function we_tag_ifClient(array $attribs){
	return we_tag_ifClient::tag($attribs);
}
