<?php

/**
 * webEdition CMS
 *
 * $Rev: cc823e5005ff $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:01 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifShopCategory extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$field = self::getAttribute('field', $attribs, 'id', we_base_request::STRING);
		$match = intval(self::getAttribute('match', $attribs, false, we_base_request::INT));
		$ignorefallbacks = self::getAttribute('ignorefallbacks', $attribs, false, we_base_request::BOOL);
		$lvOnly = self::getAttribute('lvOnly', $attribs, false, we_base_request::BOOL);

		if(we_tag_listview::$current){
			$catID = we_tag_listview::$current->f(we_shop_shop::CATEGORY_FIELD_NAME) ?: 0;
			$wedocCategory = we_tag_listview::$current->f(we_listview_base::CATEGORY_FIELD) ?: '';
		} elseif(!$lvOnly){
			$catID = $GLOBALS['we_doc']->getElement(we_shop_shop::CATEGORY_FIELD_NAME) ?: 0;
			$wedocCategory = $GLOBALS['we_doc']->Category ?: '';
		} else {
			return false;
		}

		$validArr = we_shop_category::checkGetValidID($catID, $wedocCategory, true, true);
		$validID = intval($validArr['id']);

		switch($field){
			case 'is_from doc_object':
				return boolval($validArr['state'] === we_shop_category::IS_CAT_FALLBACK_TO_WEDOCCAT) || boolval($validArr['state'] === we_shop_category::IS_CAT_FALLBACK_TO_WEDOCCAT_AND_ACTIVE);
			case 'is_fallback_to_standard':
				return boolval($validArr['state'] === we_shop_category::IS_CAT_FALLBACK_TO_STANDARD);
			case 'is_fallback_to_active':
				return boolval($validArr['state'] === we_shop_category::IS_CAT_FALLBACK_TO_ACTIVE) || boolval($validArr['state'] === we_shop_category::IS_CAT_FALLBACK_TO_WEDOCCAT_AND_ACTIVE);
			case 'is_destinationprinciple':
				return boolval(we_shop_category::getShopCatFieldByID($validID, $wedocCategory = '', 'DestPrinciple'));
			case 'id':
				if(!$match){
					return $ignorefallbacks ? boolval($catID) : boolval($validID);
				}
				return $ignorefallbacks ? $catID === $match : $validID === $match;

			default:
				return false;
		}
	}

}

function we_tag_ifShopCategory(array $attribs){
	return we_tag_ifShopCategory::tag($attribs);
}
