<?php

/**
 * webEdition CMS
 *
 * $Rev: e0286bdca1e3 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-09-05 12:54 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_registerSwitch extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!$GLOBALS['we']['editmode']){
			return '';
		}

		if(($val = we_base_request::_(we_base_request::BOOL, 'we_set_registeredUser', -1)) !== -1 && $GLOBALS['we']['main']['doc']->InWebEdition){
			$GLOBALS['we']['main']['doc']->setEditorPersistent('registered', $val);
		}

		$val = (bool) $GLOBALS['we']['main']['doc']->getEditorPersistent('registered');

		return '
<table class="we weEditTable we_switcher">
	<tr><td><b>' . g_l('modules_customer', '[view]') . ':</b></td>
	<td><input id="set_registered" type="radio" name="we_set_registeredUser" value="1" onclick="top.we_cmd(\'reload_editpage\');"' . ($val ? ' checked' : '') . ' /><label for="set_registered">' . g_l('modules_customer', '[registered_user]') . '</label></td>
	<td><input id="set_unregistered" type="radio" name="we_set_registeredUser" value="0" onclick="top.we_cmd(\'reload_editpage\');"' . (!$val ? ' checked' : '') . ' /><label for="set_unregistered">' . g_l('modules_customer', '[unregistered_user]') . '</label></td>
	</tr>
</table>';
	}

}

function we_tag_registerSwitch(){
	return we_tag_registerSwitch::tag();
}
