<?php

/**
 * webEdition CMS
 *
 * $Rev: e767e93ac5e5 $
 * $Author: mokraemer $
 * $Date: 2019-05-27 17:47 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_registeredUser extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$show = self::getAttribute('show', $attribs, '', we_base_request::STRING);
		$docAttr = self::getAttribute('doc', $attribs, '', we_base_request::STRING);
		$regs = [];
		if(preg_match('|^field:(.+)$|', $id, $regs)){
			$doc = self::getDocForTag($docAttr);
			$field = $regs[1];
			if(strlen($field)){
				$id = $doc->getElement($field);
			}
		}
		if($id){
			$h = getHash('SELECT * FROM ' . CUSTOMER_TABLE . ' WHERE ID=' . intval($id));
			if(!$h){
				return '';
			}
			unset($h['Password']);
			$h = array_merge($h, we_customer_customer::getEncryptedFields());
			if($show){
				$foo = [];
				preg_match_all('|%([^ ]+) ?|i', $show, $foo, PREG_SET_ORDER);
				foreach($foo as $f){
					$show = str_replace('%' . $f[1], $h[$f[1]], $show);
				}
				return $show;
			}
			return $h['Username'];
		}
		return '';
	}

}

function we_tag_registeredUser(array $attribs){
	return we_tag_registeredUser::tag($attribs);
}
