<?php

/**
 * webEdition CMS
 *
 * $Rev: 32dc09780205 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-01-08 13:57 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_sidebar extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		return '<?php ob_start();?>' . $content . '<?= ' . we_weTag_parser::printTag('sidebar', $attribs, 'ob_get_clean()', false, true) . '; ?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(SIDEBAR_DISABLED || (we_tag('ifNotEditmode') && !defined('WE_SIDEBAR'))){
			return '';
		}
		$id = intval(self::getAttribute('id', $attribs, 0, we_base_request::INT));
		$file = self::getAttribute('file', $attribs, '', we_base_request::FILE);
		$url = self::getAttribute('url', $attribs, '', we_base_request::URL);
		//$anchor = self::getAttribute('anchor', $attribs);
		$width = self::getAttribute('width', $attribs, SIDEBAR_DEFAULT_WIDTH, we_base_request::UNIT);
		$params = self::getAttribute('params', $attribs, '', we_base_request::RAW);
		$type = self::getAttribute('type', $attribs, 'link', we_base_request::STRING);
		if($params && strpos($params, '?') === 0){
			$params = substr($params, 1);
		}

		removeAttribs($attribs, ['id', 'file', 'url', 'width', 'href', 'params', 'anchor']);

		if(!trim($content)){
			$content = g_l('weTag', '[sidebar][open_sidebar]');
		}
		switch($type){
			default:
			case 'link':
				if($id){
					if(!f('SELECT 1 FROM ' . FILE_TABLE . ' WHERE ID=' . intval($id))){
						return $content;
					}
					$attribs['href'] = "javascript:WE().layout.sidebar.open(''," . $id . ',' . $width . ",'" . $params . "');";
				} else {
					$file = ($file ?: $url);
					if(!$file){
						return $content;
					}
					$attribs['href'] = "javascript:WE().layout.sidebar.load('" . $file . "');WE().layout.sidebar.resize(" . $width . ",'" . $params . "');";
				}

				return getHtmlTag('a', $attribs, $content);
			case 'js':
				if($id && f('SELECT 1 FROM ' . FILE_TABLE . ' WHERE ID=' . intval($id))){
					return we_html_element::jsElement("WE().layout.sidebar.open(''," . $id . ',' . $width . ",'" . $params . "');");
				} elseif($file = ($file ?: $url)){
					return we_html_element::jsElement("WE().layout.sidebar.load('" . $file . "');WE().layout.sidebar.resize(" . $width . ",'" . $params . "');");
				}
				return '';
		}
	}

}

function we_tag_sidebar(array $attribs, $content){
	return we_tag_sidebar::tag($attribs, $content);
}
