<?php
/**
 * webEdition CMS
 *
 * $Rev: 342e215a2edb $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-03-21 11:07 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_html_tools::protect([we_base_perm::WORK_COLLECTION_NEW]); // FIXME: use perms
$jsCmd = new we_base_jsCmd();

$collection = new we_collection();
$collection->we_new();

$cmd = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0);
$name = we_base_request::_(we_base_request::STRING, 'we_name', '');
$fixedPID = we_base_request::_(we_base_request::INT, 'fixedpid', -1);
$fixedRemTable = we_base_request::_(we_base_request::STRING, 'fixedremtable', stripTblPrefix(FILE_TABLE));

$collection->ParentID = $fixedPID !== -1 ? $fixedPID : we_base_request::_(we_base_request::INT, 'we_' . $name . '_ParentID', 0);
$collection->ParentPath = id_to_path($collection->ParentID, $collection->Table);
$collection->remTable = stripTblPrefix(FILE_TABLE); // FIXME: make dynamic when implementing object collections
//$collection->remTable = $fixedRemTable ? : we_base_request::_(we_base_request::STRING, 'we_' . $name . '_remTable');

$id = 0;
if(we_base_request::_(we_base_request::BOOL, 'dosave')){
	$collection->ContentType = we_base_ContentTypes::COLLECTION;
	$collection->IsFolder = 0;
	$collection->we_new();

	$collection->Filename = $collection->Text = we_base_request::_(we_base_request::STRING, 'we_' . $name . '_Filename');
	$collection->Path = ($collection->ParentID == 0 ? '' : $collection->ParentPath) . '/' . $collection->Filename;
	$collection->remCT = we_base_request::_(we_base_request::STRING, 'we_' . $name . '_remCT');
	$collection->remClass = we_base_request::_(we_base_request::STRING, 'we_' . $name . '_remClass');
	$collection->IsDuplicates = we_base_request::_(we_base_request::INT, 'we_' . $name . 'IsDuplicates', 1);
	$collection->InsertRecursive = 1;
	$writeBack = [];

	if(($jsMessage = $collection->checkFieldsOnSave())){
		$jsCmd->addMsg($jsMessage, we_base_util::WE_MESSAGE_ERROR);
	} elseif($collection->we_save()){
		$jsCmd->addMsg(sprintf(g_l('weEditor', '[text/weCollection][response_save_ok]'), $collection->Text), we_base_util::WE_MESSAGE_NOTICE);
		$jsCmd->addCmd('do_onSuccess');
		$id = f('SELECT ID FROM ' . VFILE_TABLE . ' WHERE Text ="' . $collection->Text . '" AND ParentID=' . $collection->ParentID . ' LIMIT 1');
		$jsCommandOnSuccess = we_base_request::_(we_base_request::CMD, 'we_cmd', '', 1);
	} else {
		$jsCmd->addMsg('unknown error ', we_base_util::WE_MESSAGE_ERROR);
	}
}


$jsDynamicVars = ['name' => $collection->Name,
	'cmd' => $cmd,
	'cmdOnSuccess' => $jsCommandOnSuccess,
	'data' => ['id' => $id, 'text' => $collection->Path]
];

$parts = [
	['headline' => g_l('weClass', '[path]'),
		'html' => $collection->formPath($fixedPID !== -1, true),
		'noline' => true],
	['headline' => g_l('global', '[content]'),
		'html' => $collection->formContent(true),
		'noline' => true]
];

echo we_html_tools::getHtmlTop(g_l('button', '[new_collection][value]'), '', '', we_html_element::jsScript(JS_DIR . 'collection.js') .
	we_html_element::jsScript(JS_DIR . '/dialogs/we_dialog_newCollection.js', '', ['id' => 'loadVarWe_dialog_newCollection', 'data-dialog' => setDynamicVar($jsDynamicVars)]) .
	$jsCmd->getCmds(), we_html_element::body(
		['class' => 'weDialogBody',
		'onload' => 'window.focus();'
		], we_html_element::form(['method' => 'post'], we_html_element::hiddens([
				'dosave' => 0,
				'we_cmd[0]' => we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0),
				'we_cmd[1]' => we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1),
				'we_cmd[2]' => we_base_request::_(we_base_request::STRING, 'we_cmd', '', 2),
				'fixedpid' => $fixedPID,
				'fixedremtable' => $fixedRemTable,
				'we_name' => $collection->Name,
				'caller' => $caller
			]) .
			we_html_multiIconBox::getHTML(
				'weNewCollection', $parts, true, we_html_button::position_yes_no_cancel(
					we_html_button::create_button(we_html_button::SAVE, "javascript:we_cmd('save_notclose');"), '', we_html_button::create_button(we_html_button::CLOSE, "javascript:we_cmd('close');")
				), -1, '', '', false, g_l('button', '[new_collection][value]')))
));
